module hammod
    implicit none
    private
    public::ecke,solve,graph,pfad,init,n, del

    type nachb
        type(ecke),pointer::next=>NULL()
    end type

    type ecke
        integer::key
        type(nachb),dimension(:),allocatable::nachbar
    end type

    type(ecke),target,dimension(:),allocatable::graph
    integer,dimension(:),allocatable::pfad
    integer::n

    contains

    subroutine init(i,m)
        integer::i,j,k,m

        allocate(graph(i),pfad(i))
        pfad=0
        do j=1,i
            graph(j)%key=j
            allocate(graph(j)%nachbar(m))
            !do k=1,m
            !    nullify(graph(j)%nachbar(k)%next)
            !end do
        end do


        graph(1)%nachbar(1)%next=>graph(2)
        graph(2)%nachbar(1)%next=>graph(3)
        graph(3)%nachbar(1)%next=>graph(5)
        graph(4)%nachbar(1)%next=>graph(6)
        graph(5)%nachbar(1)%next=>graph(2)
        graph(6)%nachbar(1)%next=>graph(5)
        graph(1)%nachbar(2)%next=>graph(4)
        graph(3)%nachbar(2)%next=>graph(2)
        graph(1)%nachbar(3)%next=>graph(3)
        graph(5)%nachbar(2)%next=>graph(1)
        graph(3)%nachbar(3)%next=>graph(4)

    end subroutine

    recursive subroutine solve(i)
        integer::i,j
        logical::a

        n=n+1
        pfad(n)=graph(i)%key
        !write(*,*)pfad
        !write(*,*)n,i,1

        a=.False.
        do j=1,size(graph(i)%nachbar)
            if(.not.associated(graph(i)%nachbar(j)%next))cycle
            a=a.or.graph(i)%nachbar(j)%next%key==pfad(1)
        end do
        !write(*,*)n,i,2

        if(n==size(pfad).and.a)then
            write(*,*)"done",pfad
            !write(*,*)n,i,3
            !call del()
            stop

        else
            do j=1,size(graph(i)%nachbar)
                !write(*,*)n,j,4

                if(.not.associated(graph(i)%nachbar(j)%next))exit
                if(all(pfad(:)/=graph(i)%nachbar(j)%next%key))then
                    !write(*,*)n,j,5
                    !write(*,*)graph(i)%nachbar(j)%next%key

                    call solve(graph(i)%nachbar(j)%next%key)
                end if
            end do
            !write(*,*)n,i,6

            pfad(n)=0
            n=n-1
        end if
        !write(*,*)n,i,7

        if(n<1)then
            write(*,*)"No solution"
            !write(*,*)n,i,8

        end if

    end subroutine

    subroutine del()
        DEALLOCATE(graph, pfad)
    end subroutine

end module

program hamilton
    use hammod
    implicit none

    integer::i,m

    i=6
    m=3

    call init(i,m)
    n=0
    call solve(1)
    call del()

end program
