module contmod
    implicit none
    private
    public::operator(<),content

    type name
        character(15)::nname,vname
    end type

    type datum
        integer::d,m,y
    end type

    type content
        type(name)::nam
        type(datum)::dat
    end type

    interface operator (<)
        module procedure klnam,kldat
    end interface

    contains

    logical function klnam(a,b)
        type(name,intent(in)::a,b
        !klnam=a%nname<b%nname.or.a%nname=b%nname.and.a%vname<b%vname
        klnam=a%nname<b%nname
        if(a%nname==b%nname)then
            klnam=a%vname<b%vname
        end if

    end function

    logical function kldat(a,b)
        type(datum),intent(in)::a,b
        !kldat=a%y<b%y.or.a%y=b%y.and.(a%m<b%m.or.a%m=b%m.and.a%d<b%d)
        kldat=a%y<b%y
        if(a%y==b%y)then
            kldat=a%m<b%m
            if(a%m==b%m)then
                kldat=a%d<b%d
            end if
        end if

    end function

end module

module listmod
    use contmod
    implicit none
    private
    public::liste,makelist,writelist

    type elem
        type(content)::cont
        type(elem),pointer::nextdat=>null(),nextnam=>null()
        type(elem),pointer::predat=>null(),prenam=>null()
    end type

    type liste
        type(elem),pointer::headdat=>null(),headnam=>null()
        !type(elem),pointer::taildat=>null(),tailnam=>null()
    end type

    contains

    subroutine makelist(l,c)
        type(liste)::l
        type(content)::hilf
        character(*)::c
        integer::ios

        open(unit=33,file=c,action="read",iostat=ios,status="old")
        if(ios/=0)then
            write(*,*)"Fehler"
            stop
        end if
        do
            read(33,*,iostat=ios)hilf
            if(ios/=0)exit
            call insert(l,hilf)
        end do
        close(33)

    end subroutine

    subroutine insert(l,c)
        type(liste)::l
        type(content)::c
        type(elem),pointer::hilf

        allocate(hilf)
        hilf%cont=c
        if(.not.associated(l%headnam))then
            l%headdat=>hilf
            l%headnam=>hilf
            !l%taildat=>hilf
            !l%tailnam=>hilf
        else
            !nach name einsortieren
            if(c%nam<l%headnam%cont%nam)then
                hilf%nextnam=>l%headnam
                l%headnam%prenam=>hilf
                l%headnam=>hilf
            else
                hilf%nextnam=>l%headnam%nextnam
                hilf%prenam=>l%headnam
                do
                    if(.not.associated(hilf%nextnam))then
                        hilf%prenam%nextnam=>hilf
                        !l%tailnam=>hilf
                        exit
                    else if(c%nam<hilf%nextnam%cont%nam)then
                        hilf%prenam%nextnam=>hilf
                        hilf%nextnam%prenam=>hilf
                        exit
                    else
                        hilf%prenam=>hilf%nextnam
                        hilf%nextnam=>hilf%nextnam%nextnam
                    end if
                end do
            end if
            !nach datum sortieren
            if(c%dat<l%headdat%cont%dat)then
                hilf%nextdat=>l%headdat
                l%headdat%predat=>hilf
                l%headdat=>hilf
            else
                hilf%nextdat=>l%headdat%nextdat
                hilf%predat=>l%headdat
                do
                    if(.not.associated(hilf%nextdat))then
                        hilf%predat%nextdat=>hilf
                        !l%taildat=>hilf
                        exit
                    else if(c%dat<hilf%nextdat%cont%dat)then
                        hilf%predat%nextdat=>hilf
                        hilf%nextdat%predat=>hilf
                        exit
                    else
                        hilf%predat=>hilf%nextdat
                        hilf%nextdat=>hilf%nextdat%nextdat
                    end if
                end do
            end if
        end if

    end subroutine

    subroutine writelist(l)
        type(liste)::l
        type(elem),pointer::hilf
        character::a

        do
            write(*,*)"nach Namen(n) oder nach Datum(d)?"
            read(*,*)a
            if(a=="n".or.a=="d")exit
            write(*,*)"Eingabefehler"
        end do

        if(a=="n")then
            call listebynam(l)
        else
            call listebydat(l)
        end if

    end subroutine

    subroutine listebydat(l)
        type(liste)::l

        if(.not.associated(l%headdat))then
            write(*,*)"leere Liste"
        else
            !nullify(l%taildat,l%tailnam)
            nullify(l%headnam)
            write(*,*)l%headdat%cont
            if(.not.associated(l%headdat%nextdat))then
                deallocate(l%headdat)
                stop
            end if
            l%headdat=>l%headdat%nextdat

            do
                write(*,*)l%headdat%cont
                nullify(l%headdat%predat%nextdat,l%headdat%predat%nextnam,l%headdat%predat%prenam)
                deallocate(l%headdat%predat)

                if(.not.associated(l%headdat%nextdat))then
                    deallocate(l%headdat)
                    exit
                end if
                l%headdat=>l%headdat%nextdat
            end do
        end if
    end subroutine

    subroutine listebynam(l)
        type(liste)::l
        type(elem),pointer::hilf

        if(.not.associated(l%headnam))then
            write(*,*)"leere Liste"
        else
            !nullify(l%taildat,l%tailnam)
            nullify(l%headdat)
            write(*,*)l%headnam%cont
            if(.not.associated(l%headnam%nextnam))then
                deallocate(l%headnam)
                stop
            end if
            l%headnam=>l%headnam%nextnam

            do
                write(*,*)l%headnam%cont
                nullify(l%headnam%prenam%nextnam,l%headnam%prenam%nextdat,l%headnam%prenam%predat)
                deallocate(l%headnam%prenam)

                if(.not.associated(l%headnam%nextnam))then
                    deallocate(l%headnam)
                    exit
                end if
                l%headnam=>l%headnam%nextnam
            end do
        end if
    end subroutine

end module

program listsort
    use listmod
    implicit none

    character(len=15)::c
    type(liste)::l

    c="leute.dat"
    call makelist(l,trim(c))
    call writelist(l)

end program
