PROGRAM einkaufsliste
  IMPLICIT NONE

  TYPE artikel
    CHARACTER(15) :: aname
    INTEGER(1) :: amenge
    TYPE(artikel), POINTER :: next => NULL()
  END TYPE

  TYPE liste
    TYPE(artikel), POINTER :: head => NULL()
  END TYPE

  TYPE(liste) :: einkauf
  TYPE(artikel), POINTER :: p
  INTEGER :: i
  CHARACTER :: janein


  ALLOCATE(einkauf%head)
  CALL schreiben(einkauf%head)

  CALL finde (einkauf%head,'Banane')

  CALL insert(einkauf%head, 'Ananas', 5)

  CALL einkaufen(einkauf%head)

  CALL auspacken(einkauf%head)

CONTAINS


  SUBROUTINE schreiben (head) !!! kann mit insert direkt in alphabetische reihenfolge gebracht werden
    TYPE(artikel), POINTER :: head
    TYPE(artikel), POINTER :: q, p

    WRITE(*,*) 'Bitte erstes Lebensmittel und Menge eingeben.'
    READ(*,*) head%aname, head%amenge
    p => head
    DO
      WRITE(*,*) 'Noch weiter? (j/n)'
      READ(*,*) janein
      IF (janein == 'j') THEN
        ALLOCATE(p%next)
        p => p%next
        WRITE(*,*) 'Bitte naechstes Lebensmittel und Menge eingeben.'
        READ(*,*) p%aname, p%amenge
      ELSE
        EXIT
      END IF
    END DO
  END SUBROUTINE






  SUBROUTINE insert (head, artikelname, anz)
    TYPE(artikel), POINTER :: head
    TYPE(artikel), POINTER :: q, p
    CHARACTER(*) :: artikelname
    INTEGER :: anz


    q=>head
    IF(associated(q))THEN
      IF(TRIM(artikelname) <= TRIM(q%aname))THEN
        IF(TRIM(artikelname) == TRIM(q%aname)) THEN
          WRITE(*,*) q%amenge, ' mal ', TRIM(q%aname), ' steht bereits auf der Liste.'
          WRITE(*,*) 'Die Anzahl wird um', anz, ' erhoeht.'
          q%amenge = q%amenge + anz
        ELSE
          WRITE(*,*) anz, ' mal ', TRIM(artikelname), ' wird auf die Liste geschrieben.'
          ALLOCATE(head)
          head%aname = TRIM(artikelname)
          head%amenge = anz
          head%next => q
        END IF
      ELSE
        DO
          IF (ASSOCIATED(q%next)) THEN
            IF(TRIM(artikelname) <= TRIM(q%next%aname)) THEN

              ! TEST, ob Artikel schon auf der Liste steht:
              IF(TRIM(artikelname) == TRIM(q%next%aname)) THEN
                WRITE(*,*) q%next%amenge, ' mal ', TRIM(q%next%aname), ' steht bereits auf der Liste.'
                WRITE(*,*) 'Die Anzahl wird um', anz, ' erhoeht.'
                q%next%amenge = q%next%amenge + anz
                EXIT
              ELSE
                WRITE(*,*) anz, ' mal ', TRIM(artikelname), ' wird vor ', &
                              & TRIM(q%next%aname), ' auf die Liste geschrieben.'
                p => q%next
                ALLOCATE(q%next)
                q%next%aname = TRIM(artikelname)
                q%next%amenge = anz
                q%next%next => p
                EXIT
              END IF
            ELSE
              q => q%next
            END IF
          ELSE
            WRITE(*,*) anz, ' mal ', TRIM(artikelname), ' wird an das Ende der Liste geschrieben.'
            ALLOCATE(q%next)
            q%next%aname = TRIM(artikelname)
            q%next%amenge = anz
            EXIT
          END IF
        END DO
      END IF
    ELSE
      WRITE(*,*) 'Die Liste ist leer.'
      WRITE(*,*) anz, ' mal ', TRIM(artikelname), ' wird auf die Liste geschrieben.'
      ALLOCATE(head)
      head%aname = TRIM(artikelname)
      head%amenge = anz
    END IF


  END SUBROUTINE





  ! Ausgabe OHNE Laenge der Liste zu verwenden:
  SUBROUTINE einkaufen(head)
    TYPE(artikel), POINTER :: head
    TYPE(artikel), POINTER :: q
    INTEGER :: i

    q => head

    DO
      IF (ASSOCIATED(q)) THEN
        WRITE(*,*) 'Du legst', q%amenge, ' mal ', TRIM(q%aname), ' in den Einkaufswagen.'
        q => q%next
      ELSE
        EXIT
      END IF
    END DO
  END SUBROUTINE

  SUBROUTINE auspacken(head)
    TYPE(artikel), POINTER :: head
    TYPE(artikel), POINTER :: q

    WRITE(*,*)
    WRITE(*,*) 'Jetzt wird ausgepackt!'
    DO
      q => head
      IF (ASSOCIATED(q)) THEN
        WRITE(*,*) 'Du packst', q%amenge, ' mal ', TRIM(q%aname), ' in den (Kuehl-) Schrank.'
        head => q%next
        DEALLOCATE(q)
      ELSE
        EXIT
      END IF
    END DO

  END SUBROUTINE



  SUBROUTINE finde (head, artikelname)
    TYPE(artikel), POINTER :: head
    TYPE(artikel), POINTER :: q, p
    CHARACTER(*) :: artikelname

    !finde=.true.
    q => head
    IF (ASSOCIATED(q)) THEN
      IF(TRIM(q%aname) == TRIM(artikelname)) THEN
        WRITE(*,*) q%amenge, ' mal ', TRIM(q%aname), ' wird von der Liste gestrichen.'
        head => q%next
        deallocate(q)
      ELSE
        DO
          IF (ASSOCIATED(q%next)) THEN
            IF(TRIM(q%next%aname) == TRIM(artikelname)) THEN
              WRITE(*,*) q%next%amenge, ' mal ', TRIM(q%next%aname), ' wird von der Liste gestrichen.'
              p => q%next
              q%next => q%next%next
              deallocate(p)
              EXIT
            ELSE
              q => q%next
            END IF
          ELSE
            WRITE(*,*) TRIM(artikelname), ' steht nicht auf der Liste. '
            !finde = .FALSE.
            EXIT
          END IF
        END DO
      END IF
    ELSE
      WRITE(*,*) 'Die Liste ist leer.'
      !finde = .FALSE.
    END IF



  END SUBROUTINE




END PROGRAM
